<?php

	//error_reporting (0);
	define('_JEXEC', 1);
	define('DS', DIRECTORY_SEPARATOR);
	$option='com_jshopping';
	$my_path = dirname(__FILE__);
	$my_path = explode(DS.'components',$my_path);	
	$my_path = $my_path[0];			
	if (file_exists($my_path . '/defines.php')) {
		include_once $my_path . '/defines.php';
		}
	if (!defined('_JDEFINES')) {
		define('JPATH_BASE', $my_path);
	    require_once JPATH_BASE.'/includes/defines.php';
    }
	define('JPATH_COMPONENT',				JPATH_BASE . '/components/' . $option);
	define('JPATH_COMPONENT_SITE',			JPATH_SITE . '/components/' . $option);
	define('JPATH_COMPONENT_ADMINISTRATOR',	JPATH_ADMINISTRATOR . '/components/' . $option);

	require_once JPATH_BASE.'/includes/framework.php';
	$app = JFactory::getApplication('site');
	$app->initialise();

    require_once (JPATH_COMPONENT_SITE."/lib/factory.php");
    require_once (JPATH_COMPONENT_SITE.'/lib/functions.php');
    include_once(JPATH_COMPONENT_SITE."/controllers/checkout.php");
    include_once(JPATH_COMPONENT_SITE."/payments/pm_paysto/pm_paysto.php");


	JTable::addIncludePath(JPATH_COMPONENT.DS.'tables');
	jimport('joomla.application.component.model'); 
	JModel::addIncludePath(JPATH_COMPONENT.DS.'models');

    $checkout = JModel::getInstance('checkout', 'jshop');

    $pm_paysto = new pm_paysto();

	$invoice = isset($_POST['PAYSTO_INVOICE_ID'])?(int)$_POST['PAYSTO_INVOICE_ID']:0;	
	$hash = isset($_POST['PAYSTO_MD5'])?$_POST['PAYSTO_MD5']:'';
	
	$pay_class=new JshoppingControllerCheckout();
	$order = JTable::getInstance('order', 'jshop');
	$order->load($invoice); 
	
	$pm_method = JTable::getInstance('paymentMethod', 'jshop');
	$pm_method->load($order->payment_method_id);
	$pmconfigs = $pm_method->getConfigs();

    $logData = $_POST;
	
	if(!$pm_paysto->isValidSignature($hash)){
        $logData['error'] = 'No Valid Signarure';
        $pm_paysto->log($logData, false);
        exit();
    }


	if(!$pm_paysto->isValidIP($_SERVER['REMOTE_ADDR']))
    {
        $logData['error'] = 'No Valid Remote IP';
        $pm_paysto->log($logData, false);
        exit();
    }

    $cource = 1;
    if(!in_array($order->currency_code, array("RUB", "RUR")))
    {
        $db = JFactory::getDbo();
        $query = 'SELECT `currency_value`
                      FROM `#__jshopping_currencies`
                      WHERE `currency_code_iso`="RUB" OR `currency_code_iso`="RUR"
                      LIMIT 1';
        $db->setQuery($query);
        $rubCource = $db->loadResult();
        $rubCource = (!empty($rubCource)) ? $rubCource : 1;

        $query = 'SELECT `currency_value`
                      FROM `#__jshopping_currencies`
                      WHERE `currency_code_iso`="'.$order->currency_code.'"
                      LIMIT 1';
        $db->setQuery($query);
        $currencyCource = $db->loadResult();
        $currencyCource = (!empty($currencyCource)) ? $currencyCource : 1;

        $cource = $rubCource/$currencyCource;
    }

    $amount = number_format(floatval($order->order_total*$cource), 2, '.', '');

	if( !isset($_POST['PAYSTO_SUM']) || $amount != $_POST['PAYSTO_SUM'])
    {
        $logData['error'] = 'No Valid Summ';
        $pm_paysto->log($logData, false);
        exit();
    }

    $requestMode = (!empty($_POST['PAYSTO_REQUEST_MODE'])) ? $_POST['PAYSTO_REQUEST_MODE'] : '';

    //подтверждение платежа
	if($requestMode == 'CHECK')
    {
        $logData['state'] = 'CHECK';
        $pm_paysto->log($logData, true);
        exit($_POST['PAYSTO_INVOICE_ID']);
    }

	
	$pay_class=new JshoppingControllerCheckout();

        /* $requestMode ansver codes (payment statuses)
        RES_BILLED – заявка отправлена на оплату,
        RES_CANCEL - покупатель отказался от покупки,
        RES_CREATED – заявка зарегистрирована,
        RES_ERROR - при платеже произошли ошибки,
        RES_HOLD - заявка приостановлена;
        RES_PAID - оплата состоялась,
        */
    switch($requestMode){
        case 'RES_ERROR':
        case 'RES_CANCEL':
            $status = $pmconfigs['transaction_failed_status'];
            break;
        case 'RES_PAID':
            $status = $pmconfigs['transaction_end_status'];
            break;
        case 'RES_BILLED':
        case 'RES_CREATED':
        case 'RES_HOLD':
        default:
            $status = $pmconfigs['transaction_pending_status'];
            break;
    }

    $jshopConfig = JSFactory::getConfig();
    JSFactory::loadLanguageFile();

    if ($status && !$order->order_created)
    {
        $order->order_created = 1;
        $order->order_status = $status;
        $order->store();

        if ($jshopConfig->send_order_email)
        {
            $checkout->sendOrderEmail($order->order_id);
        }

        $order->changeProductQTYinStock("-");
        $checkout->changeStatusOrder($order->order_id, $status, 0);
    }

    if ($status && $order->order_status != $status){
        $checkout->changeStatusOrder($order->order_id, $status, 1);
    }

    $logData['state'] = 'SUCCES';
    $pm_paysto->log($logData, true);
    exit($_POST['PAYSTO_INVOICE_ID']);


?>
